unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure PrintCmRuler;
    procedure PrintInchesRuler;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses PRINTERS;

procedure Tform1.PrintInchesRuler;
var i,j,k,m : integer;
begin  PrinterSetupDialog1.Execute;
  printer.BeginDoc;
  //Each logical unit is mapped to 0.1 millimeter.
  //Positive x is to the right; positive y is up.
  SetMapMode(printer.Canvas.Handle, MM_HIENGLISH); //unit is 1/1000 inch
   with printer.Canvas do
   begin font.Size:=20;  k:=10600; m:=-1; //
   for i:=0 to k-300  do
   begin  j:=i-k;
      if i mod 1000 =0 then
      begin moveto(0,j); lineto(300,j); //moveto(0,j);
            inc(m);
            textout(301,j+150,inttostr(m))
      end
      else
      if i mod 500 =0 then
      begin
            moveto(0,j); lineto(150,j);
      end else
      if i mod 100 =0 then
      begin
          moveto(0,j); lineto(100,j);
      end;
   end;
   moveto(0,0); lineto(0,-k)
   end;
   printer.EndDoc
end;

procedure Tform1.PrintCmRuler;
var j,k,margin,m : integer;
begin  PrinterSetupDialog1.Execute; //for best result set it to 300 DPI
  printer.BeginDoc;
  margin:=0; //margin in inches if desired
  //Each logical unit is mapped to 0.1 millimeter.
  //Positive x is to the right; positive y is up.
  SetMapMode(printer.Canvas.Handle, MM_HIMETRIC); // unit is 1/100 milimeter
   with printer.Canvas do
   begin font.Size:=60; k:=-26500;
   for j:=0 downto k  do //10*image1.Height-1 do
   begin m:=26-(-j div 1000);
      if j mod 1000 =0 then
      begin moveto(margin,j); lineto(margin+750,j); //moveto(0,j);
            textout(margin+760,j,inttostr(m))
      end
      else
      if (m>0)and(j mod 500 =0) then
      begin
            moveto(margin,j); lineto(margin+300,j);
      end else
      if (m>0)and(j mod 100 =0) then
      begin
          moveto(margin,j); lineto(150+margin,j);
      end;
   end;
   moveto(margin,0); lineto(margin,k)
   end;
   printer.EndDoc
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if RadioGroup1.ItemIndex=0 then PrintCmRuler else PrintInchesRuler
end;

procedure TForm1.Button2Click(Sender: TObject);
begin  printer.BeginDoc;
    SetMapMode(printer.Canvas.Handle, MM_HIMETRIC); // unit is 1/100 milimeter
    showmessage('H='+inttostr(printer.PageHeight)+'  W='+inttostr(printer.PageWidth));
    printer.EndDoc
end;

end.
